"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");var _keys=_interopRequireDefault(require("@babel/runtime/core-js/object/keys"));var _classCallCheck2=_interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));var _createClass2=_interopRequireDefault(require("@babel/runtime/helpers/createClass"));var fs=require('fs');var octicons=require('octicons');var path=require('path');var glob=require('glob');var changeCase=require('change-case');var atomApp=process.env.atomApp||'Atom';var terminalApp=process.env.terminalApp||'Terminal';var Project=function(){function Project(){(0,_classCallCheck2.default)(this,Project);}(0,_createClass2.default)(Project,[{key:"_fileExists",value:function _fileExists(path){try{fs.statSync(path);return true;}catch(err){return false;}}},{key:"_uid",value:function _uid(project){return project.title.toLowerCase().replace(' ','_');}},{key:"_title",value:function _title(project){var title=project.title;if(project.group){title+=' - '+project.group;}return title;}},{key:"_subtitle",value:function _subtitle(project){if(project.paths){return project.paths.join(', ');}return'';}},{key:"_icon",value:function _icon(project){var iconPaths=[];if(project.icon){if(project.icon.startsWith('icon-')){var octiconNames=(0,_keys.default)(octicons);if(octiconNames.indexOf(project.icon.slice(5))>=0){return path.join(__dirname,'icons',project.icon.slice(5)+'.png');}}if(project.icon.startsWith('~/')){var homedir=process.env.HOME||'';project.icon=path.resolve(homedir,project.icon.slice(2));}if(!path.isAbsolute(project.icon)){for(var i=0;i<project.paths.length;i++){iconPaths.push(path.resolve(project.paths[i],project.icon));}}if(this._fileExists(project.icon)){return project.icon;}}for(var _i=0;_i<project.paths.length;_i++){iconPaths.push(path.join(project.paths[_i],'icon.png'));}for(var _i2=0;_i2<iconPaths.length;_i2++){if(this._fileExists(iconPaths[_i2])){return iconPaths[_i2];}}return'icon.png';}},{key:"_openArgument",value:function _openArgument(project,app){var args=arguments.length>2&&arguments[2]!==undefined?arguments[2]:[];var command=['open','-na',`"${app}"`];if(project.paths){command.push('"'+project.paths.join('" "')+'"');}if(args.length>0){command.push('--args');command=command.concat(args);}return command.join(' ');}},{key:"parse",value:function parse(project){if(!project.paths){console.warn('Skipping project missing paths, possibly a template.');return null;}var item={uid:Buffer.from(this._title(project)+this._subtitle(project),'utf8').toString('base64'),title:this._title(project),subtitle:this._subtitle(project),icon:{path:this._icon(project)},arg:this._openArgument(project,atomApp),valid:project.paths&&project.paths.length>0,mods:{alt:{valid:true,subtitle:'Open project path(s) in terminal',arg:this._openArgument(project,terminalApp)},cmd:{valid:true,subtitle:'Open in new window',arg:this._openArgument(project,atomApp,['-n'])},ctrl:{valid:true,subtitle:'Open in development mode',arg:this._openArgument(project,atomApp,['-d'])},fn:{valid:true,subtitle:'Append project path(s) to last open window',arg:this._openArgument(project,atomApp,['-a'])},shift:{valid:true,subtitle:'Open project path(s) in finder',arg:this._openArgument(project,'Finder')}}};return item;}},{key:"parseAll",value:function parseAll(projects){var result=[];for(var i=0;i<projects.length;i++){var project=this.parse(projects[i]);if(project!==null&&project!==undefined){result.push(project);}}return result;}},{key:"findGitRepositories",value:function findGitRepositories(projectHome){var prettifyTitle=arguments.length>1&&arguments[1]!==undefined?arguments[1]:true;var projects=[];var dirs=glob.sync('*/.git',{cwd:projectHome});dirs.forEach(function(dir){dir=dir.substring(0,dir.indexOf('/.git'));var project={title:prettifyTitle?changeCase.title(dir):dir,group:'Git repository',paths:[path.resolve(projectHome,dir)]};projects.push(project);});return this.parseAll(projects);}}]);return Project;}();module.exports=new Project();
//# sourceMappingURL=project.js.map
